/*
 * MATLAB Compiler: 3.0
 * Date: Wed Aug 25 13:39:08 2004
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-W" "main" "-L" "C"
 * "-t" "-T" "link:lib" "-h" "test_track" "libmmfile.mlib" "-v" 
 */
#include "compute_windowed_fft.h"
#include "block2fft.h"
#include "libmatlbm.h"
#include "makeblocks.h"
static mxArray * _mxarray0_;
static mxArray * _mxarray1_;
static mxArray * _mxarray2_;
static mxArray * _mxarray3_;
static mxArray * _mxarray4_;
static mxArray * _mxarray5_;
static mxArray * _mxarray6_;

void InitializeModule_compute_windowed_fft(void) {
    _mxarray0_ = mclInitializeDouble(1.0);
    _mxarray1_ = mclInitializeDouble(.54);
    _mxarray2_ = mclInitializeDouble(.46);
    _mxarray3_ = mclInitializeDouble(6.283185307179586);
    _mxarray4_ = mclInitializeDouble(0.0);
    _mxarray5_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
    _mxarray6_ = mclInitializeDouble(2.0);
}

void TerminateModule_compute_windowed_fft(void) {
    mxDestroyArray(_mxarray6_);
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray1_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mcompute_windowed_fft(int nargout_,
                                       mxArray * wav,
                                       mxArray * fs,
                                       mxArray * freq_bounds,
                                       mxArray * windowsize,
                                       mxArray * overlap);

_mexLocalFunctionTable _local_function_table_compute_windowed_fft
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfCompute_windowed_fft" contains the normal interface for the
 * "compute_windowed_fft" M-function from file
 * "/afs/cs.cmu.edu/user/dhoiem/code_for_c/compute_windowed_fft.m" (lines
 * 1-43). This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfCompute_windowed_fft(mxArray * wav,
                                  mxArray * fs,
                                  mxArray * freq_bounds,
                                  mxArray * windowsize,
                                  mxArray * overlap) {
    int nargout = 1;
    mxArray * bands = NULL;
    mlfEnterNewContext(0, 5, wav, fs, freq_bounds, windowsize, overlap);
    bands
      = Mcompute_windowed_fft(
          nargout, wav, fs, freq_bounds, windowsize, overlap);
    mlfRestorePreviousContext(0, 5, wav, fs, freq_bounds, windowsize, overlap);
    return mlfReturnValue(bands);
}

/*
 * The function "mlxCompute_windowed_fft" contains the feval interface for the
 * "compute_windowed_fft" M-function from file
 * "/afs/cs.cmu.edu/user/dhoiem/code_for_c/compute_windowed_fft.m" (lines
 * 1-43). The feval function calls the implementation version of
 * compute_windowed_fft through this function. This function processes any
 * input arguments and passes them to the implementation version of the
 * function, appearing above.
 */
void mlxCompute_windowed_fft(int nlhs,
                             mxArray * plhs[],
                             int nrhs,
                             mxArray * prhs[]) {
    mxArray * mprhs[5];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: compute_windowed_fft Line: 9 Col"
            "umn: 1 The function \"compute_windowed_fft\" was calle"
            "d with more than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 5) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: compute_windowed_fft Line: 9 Col"
            "umn: 1 The function \"compute_windowed_fft\" was calle"
            "d with more than the declared number of inputs (5)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 5 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 5; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 5, mprhs[0], mprhs[1], mprhs[2], mprhs[3], mprhs[4]);
    mplhs[0]
      = Mcompute_windowed_fft(
          nlhs, mprhs[0], mprhs[1], mprhs[2], mprhs[3], mprhs[4]);
    mlfRestorePreviousContext(
      0, 5, mprhs[0], mprhs[1], mprhs[2], mprhs[3], mprhs[4]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mcompute_windowed_fft" is the implementation version of the
 * "compute_windowed_fft" M-function from file
 * "/afs/cs.cmu.edu/user/dhoiem/code_for_c/compute_windowed_fft.m" (lines
 * 1-43). It contains the actual compiled code for that M-function. It is a
 * static function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * % Computes the windowed fft of the audiofile
 * % windowsize is the size of the FFT window in seconds
 * % overlap is the nubmer of windows that overlap, so an overlap of 32
 * % implies that the shift between windows is 1/32 of a window
 * % recommended values for sound detection: 
 * %  fs = 8000, minfreq = 50, maxfreq = 4000, numbands = 32,
 * %  windowsize = 1024, overlap = 16
 * 
 * function bands = compute_windowed_fft(wav, fs, freq_bounds, windowsize, overlap)
 */
static mxArray * Mcompute_windowed_fft(int nargout_,
                                       mxArray * wav,
                                       mxArray * fs,
                                       mxArray * freq_bounds,
                                       mxArray * windowsize,
                                       mxArray * overlap) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(
          &_local_function_table_compute_windowed_fft);
    mxArray * bands = NULL;
    mxArray * tend = NULL;
    mxArray * tstart = NULL;
    mxArray * seconds = NULL;
    mxArray * i = NULL;
    mxArray * hann_window = NULL;
    mxArray * p = NULL;
    mxArray * tl = NULL;
    mxArray * maxfreq = NULL;
    mxArray * minfreq = NULL;
    mxArray * numblocks = NULL;
    mxArray * blocks = NULL;
    mclCopyArray(&wav);
    mclCopyArray(&fs);
    mclCopyArray(&freq_bounds);
    mclCopyArray(&windowsize);
    mclCopyArray(&overlap);
    /*
     * 
     * blocks = makeblocks(wav, windowsize, overlap);
     */
    mlfAssign(
      &blocks,
      mlfMakeblocks(
        mclVa(wav, "wav"),
        mclVa(windowsize, "windowsize"),
        mclVa(overlap, "overlap")));
    /*
     * numblocks = length(blocks);
     */
    mlfAssign(&numblocks, mlfScalar(mclLengthInt(mclVv(blocks, "blocks"))));
    /*
     * 
     * minfreq = freq_bounds(1);
     */
    mlfAssign(&minfreq, mclIntArrayRef1(mclVa(freq_bounds, "freq_bounds"), 1));
    /*
     * maxfreq = freq_bounds(end);
     */
    mlfAssign(
      &maxfreq,
      mclArrayRef1(
        mclVa(freq_bounds, "freq_bounds"),
        mlfEnd(mclVa(freq_bounds, "freq_bounds"), _mxarray0_, _mxarray0_)));
    /*
     * 
     * tl = length(block2fft(wav(blocks(1) : blocks(1) + windowsize - 1),  fs, minfreq, maxfreq));
     */
    mlfAssign(
      &tl,
      mlfScalar(
        mclLengthInt(
          mlfBlock2fft(
            mclArrayRef1(
              mclVa(wav, "wav"),
              mlfColon(
                mclIntArrayRef1(mclVv(blocks, "blocks"), 1),
                mclMinus(
                  mclPlus(
                    mclIntArrayRef1(mclVv(blocks, "blocks"), 1),
                    mclVa(windowsize, "windowsize")),
                  _mxarray0_),
                NULL)),
            mclVa(fs, "fs"),
            mclVv(minfreq, "minfreq"),
            mclVv(maxfreq, "maxfreq")))));
    /*
     * p = zeros(tl, numblocks);
     */
    mlfAssign(
      &p, mlfZeros(mclVv(tl, "tl"), mclVv(numblocks, "numblocks"), NULL));
    /*
     * 
     * hann_window(1:windowsize, 1) = 0.54 + 0.46*cos(2*pi*(0:windowsize-1)/(windowsize-1));
     */
    mclArrayAssign2(
      &hann_window,
      mclPlus(
        _mxarray1_,
        mclMtimes(
          _mxarray2_,
          mlfCos(
            mclMrdivide(
              mclMtimes(
                _mxarray3_,
                mlfColon(
                  _mxarray4_,
                  mclMinus(mclVa(windowsize, "windowsize"), _mxarray0_),
                  NULL)),
              mclMinus(mclVa(windowsize, "windowsize"), _mxarray0_))))),
      mlfColon(_mxarray0_, mclVa(windowsize, "windowsize"), NULL),
      _mxarray0_);
    /*
     * 
     * for (i = 1:numblocks)
     */
    {
        int v_ = mclForIntStart(1);
        int e_ = mclForIntEnd(mclVv(numblocks, "numblocks"));
        if (v_ > e_) {
            mlfAssign(&i, _mxarray5_);
        } else {
            /*
             * p(:, i) = block2fft(wav(blocks(i) : blocks(i) + windowsize - 1).*hann_window, fs, minfreq, maxfreq);
             * end
             */
            for (; ; ) {
                mclArrayAssign2(
                  &p,
                  mlfBlock2fft(
                    mclTimes(
                      mclArrayRef1(
                        mclVa(wav, "wav"),
                        mlfColon(
                          mclIntArrayRef1(mclVv(blocks, "blocks"), v_),
                          mclMinus(
                            mclPlus(
                              mclIntArrayRef1(mclVv(blocks, "blocks"), v_),
                              mclVa(windowsize, "windowsize")),
                            _mxarray0_),
                          NULL)),
                      mclVv(hann_window, "hann_window")),
                    mclVa(fs, "fs"),
                    mclVv(minfreq, "minfreq"),
                    mclVv(maxfreq, "maxfreq")),
                  mlfCreateColonIndex(),
                  mlfScalar(v_));
                if (v_ == e_) {
                    break;
                }
                ++v_;
            }
            mlfAssign(&i, mlfScalar(v_));
        }
    }
    /*
     * 
     * %bands = power2band(p, numbands, minfreq, maxfreq);
     * 
     * %x = exp(log(maxfreq / minfreq) / (numbands));
     * 
     * seconds = size(p,1)/(maxfreq-minfreq);
     */
    mlfAssign(
      &seconds,
      mclMrdivide(
        mlfSize(mclValueVarargout(), mclVv(p, "p"), _mxarray0_),
        mclMinus(mclVv(maxfreq, "maxfreq"), mclVv(minfreq, "minfreq"))));
    /*
     * 
     * bands = zeros(length(freq_bounds)-1, size(p, 2));
     */
    mlfAssign(
      &bands,
      mlfZeros(
        mlfScalar(mclLengthInt(mclVa(freq_bounds, "freq_bounds")) - 1),
        mlfSize(mclValueVarargout(), mclVv(p, "p"), _mxarray6_),
        NULL));
    /*
     * 
     * for (i = 1:length(freq_bounds)-1)
     */
    {
        int v_ = mclForIntStart(1);
        int e_ = mclLengthInt(mclVa(freq_bounds, "freq_bounds")) - 1;
        if (v_ > e_) {
            mlfAssign(&i, _mxarray5_);
        } else {
            /*
             * 
             * %tstart = floor(((x^i)-1)*minfreq*seconds+1);
             * %tend = floor((x^(i+1)-1)*minfreq*seconds);  
             * tstart = floor((freq_bounds(i)-minfreq)*seconds+1);
             * tend = floor((freq_bounds(i+1)-minfreq)*seconds);
             * bands(i, :) = sum( p(tstart : tend, :), 1 );
             * 
             * end
             */
            for (; ; ) {
                mlfAssign(
                  &tstart,
                  mlfFloor(
                    mclPlus(
                      mclMtimes(
                        mclMinus(
                          mclIntArrayRef1(
                            mclVa(freq_bounds, "freq_bounds"), v_),
                          mclVv(minfreq, "minfreq")),
                        mclVv(seconds, "seconds")),
                      _mxarray0_)));
                mlfAssign(
                  &tend,
                  mlfFloor(
                    mclMtimes(
                      mclMinus(
                        mclIntArrayRef1(
                          mclVa(freq_bounds, "freq_bounds"), v_ + 1),
                        mclVv(minfreq, "minfreq")),
                      mclVv(seconds, "seconds"))));
                mclArrayAssign2(
                  &bands,
                  mlfSum(
                    mclArrayRef2(
                      mclVv(p, "p"),
                      mlfColon(
                        mclVv(tstart, "tstart"), mclVv(tend, "tend"), NULL),
                      mlfCreateColonIndex()),
                    _mxarray0_),
                  mlfScalar(v_),
                  mlfCreateColonIndex());
                if (v_ == e_) {
                    break;
                }
                ++v_;
            }
            mlfAssign(&i, mlfScalar(v_));
        }
    }
    mclValidateOutput(bands, 1, nargout_, "bands", "compute_windowed_fft");
    mxDestroyArray(blocks);
    mxDestroyArray(numblocks);
    mxDestroyArray(minfreq);
    mxDestroyArray(maxfreq);
    mxDestroyArray(tl);
    mxDestroyArray(p);
    mxDestroyArray(hann_window);
    mxDestroyArray(i);
    mxDestroyArray(seconds);
    mxDestroyArray(tstart);
    mxDestroyArray(tend);
    mxDestroyArray(overlap);
    mxDestroyArray(windowsize);
    mxDestroyArray(freq_bounds);
    mxDestroyArray(fs);
    mxDestroyArray(wav);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return bands;
}
