#include "fil_sound_detection.h"
#include "mat.h"
#include "dt_blob.h"
#include "fil_file.h"
#include "fil_wav.h"
#include "assert.h"


int f_init_sd_test_track(int numarg, char** args, int blob_len,
			 void* blob, void** f_datap) {
  *f_datap = (void*)blob2dt(blob, blob_len);
  return 0;
}

int f_eval_sd_test_track(lf_obj_handle_t ohandle, int numout, 
			 lf_obj_handle_t *ohandles, void *f_datap) {
  
  double* data;
  int len;
  err = fread_wav_data(ohandle, &data, &len);
  assert(err == 0);

  mclInitializeApplication(NULL, 0);
  sdlibInitialize();

  mxArray* track_mx = mxCreateNumericArray(2, {len, 1}, mxDOUBLE_CLASS, mxREAL);  
  mxSetData(track_mx, (void*)&data);  
  
  /*InitializeModule_test_track();*/
  mxArray* output[2];
  mlfMtest_track(2, &output, track_mx, (mxArray*)f_datap);
  /*TerminateModule_test_track();*/
  
  mxDestroyArray(track_mx);

  mxArray* passed_times_mx = output[0];
  mxArray* confidences_mx = output[1];
  int num_passed = mxGetNumberOfElements(passed_times_mx);
  double* times = (double*)mxGetData(passed_times_mx);
  double* confidences = (double*)mxGetData(confidences_mx);

  lf_write_attr((lf_fhandle_t)0, ohandle,  
		SD_NUM_PASSED, sizeof(char*), (char*)(&num_passed));
  lf_write_attr((lf_fhandle_t)0, ohandle,  
		SD_TIMES, num_passed*sizeof(double), (char*)times);
  lf_write_attr((lf_fhandle_t)0, ohandle,  
		SD_CONFIDENCES, num_passed*sizeof(double), (char*)confidences);
  mxDestroyArray(passed_times_mx);
  mxDestroyArray(confidences_mx);


  sdlibTerminate();
  mclTerminateApplication();

  free(data);
  
}

int f_fini_sd_test_track(void* f_datap) {
  
  mclInitializeApplication(NULL, 0);
  sdlibInitialize();

  mxDestroyArray((mxArray*)f_datap);

  sdlibTerminate();
  mclTerminateApplication();

}  
