% Removes close matches, keeping the one with higher confidence and returns
% the times and scores
% min_dist is the minimum time distance required to keep two points
function [times2, scores2] = remove_close_matches(times, scores, min_dist)
    
    if size(times, 2) > 1 | size(scores, 2) > 1
        times = transpose(times);
        scores = transpose(scores);
        disp('Error: give times and scores in column format');
    end

    num_times = length(times);
            
    indices = zeros(num_times,1);
    indices(1:num_times) = (1:num_times);
        
% sort times in ascending order, scores in descending order
    T = sortrows([times indices]);
    S = -sortrows(-[scores indices]);
    keep = ones(num_times, 1);
    times2 = zeros(num_times, 1);
    scores2 = zeros(num_times, 1);
    count = 0;
    for s = 1:num_times           
        index = S(s, 2);
        if keep(index)
        count = count + 1;
        times2(count) = times(index);
        scores2(count) = scores(index);
        curr_score = S(s, 1);
        for t = 1:num_times
            if T(t, 2) == index                                
                left_dist = min_dist - 1;
                right_dist = min_dist - 1; 
                
                left_t = t-1;                
                if (left_t > 0)
                    left_dist = T(t, 1) - T(left_t, 1);
		    if left_dist < min_dist & scores(T(left_t, 2)) <= curr_score
  		         keep(T(left_t, 2)) = 0;
                    end
                end		
                while (left_t > 1  & left_dist < min_dist)
                    left_t = left_t - 1;
                    left_dist = T(t, 1) - T(left_t, 1);		    
		    if left_dist < min_dist & scores(T(left_t, 2)) <= curr_score
  		         keep(T(left_t, 2)) = 0;
                    end
                end
                
                right_t = t+1;
                if (right_t <= num_times)
                    right_dist = T(right_t, 1) - T(t, 1);
		    if right_dist < min_dist  & scores(T(right_t, 2)) <= curr_score
  		         keep(T(right_t, 2)) = 0;
                    end
                end
                while (right_t < num_times & keep(right_t) == 0 & right_dist < min_dist)
                    right_t = right_t + 1;
                    right_dist = T(right_t, 1) - T(t, 1);
		    if right_dist < min_dist & scores(T(right_t, 2)) <= curr_score
  		         keep(T(right_t, 2)) = 0;
                    end
                end
                
                break;
            end
        end
    end
    end
    %new_num = sum(keep);

     times2 = times2(1:count, 1);
     scores2 = scores2(1:count, 1);
    %times2 = zeros(new_num, 1);
    %scores2 = zeros(new_num, 1);    

    % sort by times, earliest first
    X = sortrows([times2 scores2]);    
    scores2 = X(:, 2);
    times2 = X(:, 1);


